From 6a990f8035b3e90804e31bf13ab5fa07b63eec78 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 21 2020 23:43:08 +0000
Subject: [PATCH 1769/2232] Factor out a Pair constructor for common parser use case


---

diff --git a/syntax/parse.rs b/syntax/parse.rs
index 2a42f99..b229d8b 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -497,11 +497,7 @@ fn parse_extern_fn(
     let throws = throws_tokens.is_some();
     let unsafety = foreign_fn.sig.unsafety;
     let fn_token = foreign_fn.sig.fn_token;
-    let name = Pair::new(
-        namespace,
-        cxx_name.unwrap_or(foreign_fn.sig.ident.clone()),
-        rust_name.unwrap_or(foreign_fn.sig.ident.clone()),
-    );
+    let name = pair(namespace, &foreign_fn.sig.ident, cxx_name, rust_name);
     let generics = generics.clone();
     let paren_token = foreign_fn.sig.paren_token;
     let semi_token = foreign_fn.semi_token;
@@ -1029,3 +1025,12 @@ fn parse_return_type(
         ty => Ok(Some(ty)),
     }
 }
+
+fn pair(namespace: Namespace, default: &Ident, cxx: Option<Ident>, rust: Option<Ident>) -> Pair {
+    let default = || default.clone();
+    Pair::new(
+        namespace,
+        cxx.unwrap_or_else(default),
+        rust.unwrap_or_else(default),
+    )
+}

